unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IObterUsuarios = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
  end;

implementation

type

  TObterUsuarios = class(acOQLQuery, IObterUsuarios)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

{ TObterUsuarios }

function TObterUsuarios.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterUsuarios.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ utOQLs }

class function utEmprestimoOQL.ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
begin
  result := TObterUsuarios.Create(pisessao,
'SELECT ngUsuario' + #13#10 +
'FROM ngUsuario' + #13#10 +
'WHERE (ngUsuario.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngUsuario.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

end.
